/*********************************************
 * OPL 12.6.2.0 Model
 * Author: kyjoeyvi
 * Creation Date: 2028-02-13 at 3:28:50 PM
 *********************************************/

 float data[1..12][1..11] =...;
 float Weights_ind[1..17][1..11] = ...;
 float Weights_cons[1..12][1..11] = ...;
 int maxormin[1..11] = ...;
 
 dvar float Aij_ind[1..17][1..12]; // order according to figure b1
 dvar float Aij_cons[1..12][1..12]; //1 and 2 are timber, 3 is environmentalist, 4 and 5 are Recreationalists 6 is reindeer 
 
 dvar float Aij_ind_inf[1..17][1..12]; // order according to figure b1
 dvar float Aij_cons_inf[1..12][1..12]; //1 and 2 are timber, 3 is environmentalist, 4 and 5 are Recreationalists 6 is reindeer 
 dvar float b;
 
 minimize
 b
 ;
 
 subject to {
 b == 1;
 forall(i in 1..17, j in 1..12)
   Aij_ind[i][j] == sum(k in 1..11)(Weights_ind[i][k]*(
   maxormin[k]*(data[j][k]-min(jj in 1..12)(data[jj][k]))
   /(max(jj in 1..12)(data[jj][k])-min(jj in 1..12)(data[jj][k]))+
   (1-maxormin[k])*(max(jj in 1..12)(data[jj][k])-data[j][k])
   /(max(jj in 1..12)(data[jj][k])-min(jj in 1..12)(data[jj][k]))))
   ;
 
 
forall(i in 1..17, j in 1..12)
   Aij_ind_inf[i][j] == max(k in 1..11)(Weights_ind[i][k]*(
   maxormin[k]*(data[j][k]-min(jj in 1..12)(data[jj][k]))
   /(max(jj in 1..12)(data[jj][k])-min(jj in 1..12)(data[jj][k]))
   +(1-maxormin[k])*(max(jj in 1..12)(data[jj][k])-data[j][k])
   /(max(jj in 1..12)(data[jj][k])-min(jj in 1..12)(data[jj][k]))));
   
forall(i in 1..12, j in 1..12)
   Aij_cons[i][j] == sum(k in 1..11)(Weights_cons[i][k]*(
   maxormin[k]*(data[j][k]-min(jj in 1..12)(data[jj][k]))
   /(max(jj in 1..12)(data[jj][k])-min(jj in 1..12)(data[jj][k]))+
   (1-maxormin[k])*(max(jj in 1..12)(data[jj][k])-data[j][k])
   /(max(jj in 1..12)(data[jj][k])-min(jj in 1..12)(data[jj][k]))))
   ;
 
 
forall(i in 1..12, j in 1..12)
   Aij_cons_inf[i][j] == max(k in 1..11)(Weights_cons[i][k]*(
   maxormin[k]*(data[j][k]-min(jj in 1..12)(data[jj][k]))
   /(max(jj in 1..12)(data[jj][k])-min(jj in 1..12)(data[jj][k]))
   +(1-maxormin[k])*(max(jj in 1..12)(data[jj][k])-data[j][k])
   /(max(jj in 1..12)(data[jj][k])-min(jj in 1..12)(data[jj][k]))));
   

 }  

execute {
   var ofile1 = new IloOplOutputFile("../created_data/Ranking_values_ind_Lp1.txt");
   var ofile2 = new IloOplOutputFile("../created_data/Ranking_values_ind_Lpinf.txt");
   var ofile3 = new IloOplOutputFile("../created_data/Ranking_values_cons_Lp1.txt");
   var ofile4 = new IloOplOutputFile("../created_data/Ranking_values_cons_Lpinf.txt");
	
	  
   	for (var ind=1; ind <= 17; ind=ind+ 1) {
	for (var i = 1; i <= 11; i =i+1) {
	ofile1.write(Aij_ind[ind][i],",");
      }
    ofile1.write(Aij_ind[ind][12],"\r");
   }     
        
   
   	for (var ind=1; ind <= 17; ind=ind+ 1) {
	for (var i = 1; i <= 11; i =i+1) {
	ofile2.write(Aij_ind_inf[ind][i],",");
      }
    ofile2.write(Aij_ind_inf[ind][12],"\r");
   }     

  	for (var cons=1; cons <= 12; cons=cons+ 1) {
	for (var i = 1; i <= 11; i =i+1) {
	ofile3.write(Aij_cons[cons][i],",");
      }
    ofile3.write(Aij_cons[cons][12],"\r");
   }     
        
   
   	for (var cons=1; cons <= 12; cons=cons+ 1) {
	for (var i = 1; i <= 11; i =i+1) {
	ofile4.write(Aij_cons_inf[cons][i],",");
      }
    ofile4.write(Aij_cons_inf[cons][12],"\r");
   } 
ofile1.close()
ofile2.close()
ofile3.close()
ofile4.close()
}       

