/*********************************************
 * OPL 12.6.2.0 Model
 * Author: kyjoeyvi
 * Creation Date: 2017-02-14 at 10:45:21 AM
 *********************************************/

 dvar float+ n[1..26][1..11][1..11]; // i - social group, k - group member, r,s the criteria compared
 dvar float+ p[1..26][1..11][1..11];
 dvar float+ W[1..26][1..11];
 int Matrix[1..11][1..11] =[[0,1,1,1,1,1,1,1,1,1,1],[1,0,1,1,1,1,1,1,1,1,1],[1,1,0,1,1,1,1,1,1,1,1],[1,1,1,0,1,1,1,1,1,1,1],[1,1,1,1,0,1,1,1,1,1,1],[1,1,1,1,1,0,1,1,1,1,1],[1,1,1,1,1,1,0,1,1,1,1],[1,1,1,1,1,1,1,0,1,1,1],[1,1,1,1,1,1,1,1,0,1,1],[1,1,1,1,1,1,1,1,1,0,1],[1,1,1,1,1,1,1,1,1,1,0]];;
 float m_k[1..26][1..11][1..11] =...;
 
 minimize
 
 sum(k in 1..26,i in 1..11, j in 1..11)
   (n[k][i][j]*Matrix[i][j]+p[k][i][j]*Matrix[i][j]);
   
   
subject to {

forall(i in 1..11, j in 1..11, k in 1..26)
  W[k][i]*Matrix[i][j]-(m_k[k][i][j])*W[k][j]*Matrix[i][j]+n[k][i][j]-p[k][i][j] ==0;

forall(k in 1..26)
sum(i in 1..11) W[k][i] ==1;


}   

  execute {
var ofile = new IloOplOutputFile("../created_data/Weights_ind.txt");


for (var k=1; k<= 17; k=k+1) {
for (var j=1; j<= 10; j=j+1) {
ofile.write(W[k][j],",")
}
ofile.write(W[k][11],"\r\n")

}

var ofile = new IloOplOutputFile("../created_data/Weights_cons.txt");


for (var k=18; k<= 26; k=k+1) {
for (var j=1; j<= 10; j=j+1) {
ofile.write(W[k][j],",")
}
ofile.write(W[k][11],"\r\n")

}


}
